/**
 * Clase para ejemplificar definiciones de arboles binarios y realizar recorridos sobre ellos.
 * @author ... nombre del alumno
 * @version ... fecha
 */
public class ArbolBinario {
	
	private NodoArbol raiz;
	
	/**
	 * Constructor por omision.
	 */
	public ArbolBinario() {
		raiz = null;
	}
	
	/**
	 * Constructor que inicializa un arbol binario con el nodo raiz indicado como parametro.
	 * @param raiz -- nodo raiz con el que se inicializa el arbol binario.
	 */
	public ArbolBinario(NodoArbol raiz) {
		this.raiz = raiz;
	}
	
	/**
	 * Metodo para insertar un elemento al arbol binario.
	 * @param elemento -- dato a insertar
	 */
	public void insertar(Object elemento) {
		raiz = insertar(elemento,raiz);
	}
	
    /**
     * Metodo interno para insertar un elemento al arbol binario. Se busca mantener balanceado el arbol consultando el tamanio
	 * de los subarboles.
     * @param elemento -- dato a insertar
     * @param nodo -- la raiz del arbol
     * @return NodoArbol -- la nueva raiz
     */
	private NodoArbol insertar(Object elemento, NodoArbol nodo) {
		if( nodo == null) {
			nodo = new NodoArbol(elemento);
		}
		else {
			if(tamanio(nodo.izquierda) <= tamanio(nodo.derecha))
				nodo.izquierda = insertar(elemento,nodo.izquierda);
			else
				nodo.derecha = insertar(elemento,nodo.derecha);
		}
		return nodo;
	}
	
	
	
	 //Incluir aqui el codigo
	 
	 
	 
}