/**
 * Clase para crear tablas de dispersión usando el metodo lineal para resolver colisiones y considera el metodo eliminar.
 * @author ... nombre del alumno
 * @version ... fecha
 */
public class TablaDeDispersionA2 implements Dispersable {
	private Object[] elementos;
  	private int nElementos;
	private final Object borrado = "BORRADO";
	
	/**
	 * Crea una tabla de dispersion del tamanio especificado.
	 * @param tam -- cantidad inicial de elementos permitida.
	 */
	public TablaDeDispersionA2 (int tam) {
		elementos = new Object[sgtePrimo(tam)];
		nElementos = 0;
	}
	
	/**
	 * Constructor por omision. Crea una tabla de dispersion para 101 elementos.
	 */
	public TablaDeDispersionA2 () {
		this(100);
	}
	
	/**
	 * Verifica si la tabla esta vacia.
	 * @return boolean -- true si la tabla esta vacia y false en otro caso.
	 */
	public boolean estaVacia () {
		return nElementos == 0;
	}
	
	/**
	 * Determina la cantidad de elementos en la tabla.
	 * @return int -- cantidad de elementos en la tabla.
	 */
	public int tamanio () {
		return nElementos;
	}
	
	/**
	 * Elimina todos los elementos de la tabla.
	 */
	public void vaciar () {
		for (int i = 0; i < elementos.length; i++)
			elementos[i] = null;
		nElementos = 0;
	}
	
	/**
	 * Devuelve la capacidad de la tabla.
	 * @return int -- capacidad de la tabla para almacenar elementos.
	 */
	public int capacidad () {
		return elementos.length;
	}
	
	/**
	 * Metodo para mostrar el contenido completo de la tabla.
	 */
    public void imprimir() {
		for(int i=0; i<elementos.length; i++)
  	    	System.out.print(i+":"+elementos[i]+"  ");
  		System.out.println();
    }
	
	
	
	
	
	
	
	// Incluir el codigo aqui
	
	
	
	
	
	
	
	
	/**
     * Metodo para determinar el numero primo mayor al entero dado.
     * @param n -- numero positivo inicial
     * @return int -- el numero primo mayor o igual a n.
     */
    private static int sgtePrimo(int n) {
	if(n % 2 == 0)
	    n++;

	for(; !esPrimo(n); n += 2)
	    ;

	return n;
    }

    /**
     * Metodo (ineficiente) para determinar si un numero es primo.
     * @param n -- el numero a probar
     * @return boolean -- true si el numero es primo y false en otro caso.
     */
    private static boolean esPrimo(int n)  {
	if(n == 2 || n == 3)
	    return true;

	if(n == 1 || n % 2 == 0)
	    return false;

	for(int i = 3; i * i <= n; i += 2)
	    if(n % i == 0)
		return false;

	return true;
    }
}