/**
 * Interfaz que describe las operaciones sobre una bolsa (coleccion de elementos).
 * @author Yazmin Gonzalez Bayardo
 * @version Febrero 2015
 */
public interface InterfazBolsa {
	
    /**
     * Metodo para determinar el numero de elementos en la bolsa
     * @return int - Cantidad de elementos en la coleccion
     */
	public int numElementos();
	
    /**
     * Metodo para agregar un elemento a la bolsa siempre y cuando haya espacio disponible
     * @param elemento - Elemento que se incluye a la bolsa
	 * @return boolean - Devuelve true si la operacion fue exitosa o false en otro caso
     */
	public boolean agregar(Object elemento);
	
    /**
     * Metodo para eliminar el elemento indicado todas las veces que aparezca en la bolsa. 
     * @param elemento - Elemento que se elimina de la bolsa
	 * @return boolean - Devuelve true si la operacion fue exitosa o false en otro caso
     */
	public boolean eliminar(Object elemento);
		
    /**
     * Metodo para determinar si la bolsa contiene al menos una vez al elemento indicado
     * @param elemento - Elemento que se va a buscar en la bolsa
     * @return boolean - Devuelve true si el elemento esta en la coleccion y false en otro caso
     */
	public boolean contiene (Object elemento);
	
	/**
	 * Metodo para determinar el numero de veces que un elemento dado se repite en la coleccion
	 * @param elemento - Elemento que se desea saber cuantas veces aparece en la bolsa
	 * @return int - Numero de veces que elemento aparece en la bolsa	
	 */
	public int cardinalidad (Object elemento);
}