/**
 * Programa para determinar la primer bomba de gasolina desde la cual se podra recorrer el circulo de bombas de gasolina.
 * @author Yazmin Gonzalez Bayardo
 * @version Junio 2015
 */
public class Recorrido {
	
	private ColaCircular circulo; // Cola circular para almacenar las bombas de gasolina por recorrer en el circulo.
	
	/**
	 * Constructor para simular el recorrido del circulo de bombas de gasolina.
	 */
	public Recorrido() {
		circulo = new ColaCircular();
	}
	
	/**
	 * Metodo para agregar una bomba de gasolina al circulo por recorrer.
	 * @param bg -- bomba de gasolina que sera insertado al circulo por recorrer.
	 */
	public void agregarBombaGas(BombaGasolina bg) {
		circulo.agregar(bg);
	}
	
	/**
	 * Metodo para mostrar en pantalla la informacion de las bombas de gasolina contenidas en el circulo por recorrer.
	 */
	public void mostrarBombasGas() {

		for(java.util.Iterator it = circulo.iterador(); it.hasNext();)
			System.out.println(it.next());
	}
	
	/**
	 * Metodo que determina la primer bomba de gasolina a partir de la cual se podra realizar el recorrido del circulo.
	 * Si es posible completar el recorrido, imprime en pantalla el identificador de la bomba de gasolina correspondiente al inicio del recorrido.
	 * En otro caso, se indica en pantalla que no es posible realizar el recorrido.
	 */
	public void encontrarInicio() {
		
		if(!circulo.estaVacia()) {
			
			Object inicio = circulo.tomar();
			int gasDisponible;
			boolean termino;
			
			do{
				gasDisponible = 0;
				termino = true;
				BombaGasolina bombaActual;
				
				java.util.Iterator it = circulo.iterador();
				while(it.hasNext()) {
					
					bombaActual = (BombaGasolina) it.next();
					gasDisponible += bombaActual.obtenerGasDisponible() - bombaActual.obtenerDistanciaSgte();
					
					if(gasDisponible < 0) {
						circulo.rotar();
						termino = false;
						break;
					}
				}
			}while(!termino && !(inicio.equals(circulo.tomar())));
			
			if(termino)
				System.out.println("Iniciar el recorrido en bomba de gasolina #" + ((BombaGasolina)circulo.tomar()).obtenerId());
			else
				System.out.println("No es posible hacer el recorrido.");
		}
		else {
			System.out.println("El recorrido no tiene bombas de gasolina.");
		}
		
	}
}