/**
 * Clase que define a una palabra y permite llevar un contador sobre esta.
 * @author Yazmin Gonzalez Bayardo
 * @version Agosto 2015
 */
public class Palabra {
	
	private String palabra;
	private int frecuencia;
	
	/**
     * Constructor de una Palabra a partir de una cadena de texto.
     * @param palabra -- texto que especifica la plabra
     */
	public Palabra(String palabra) {
		this.palabra = palabra;
		frecuencia = 0;
	}
	
    /**
     * Metodo para obtener la palabra.
     * @return String - palabra
     */
	public String obtenerPalabra() {
		return palabra;
	}
	
    /**
     * Metodo para obtener la frecuencia de la palabra en el archivo leido.
     * @return int - frecuencia de la palabra
     */
	public int obtenerFrecuencia() {
		return frecuencia;
	}
	
    /**
     * Metodo para incrementar en uno la frecuencia de la palabra.
     */
	public void incrementarFrec() {
		frecuencia++;
	}
	
    /**
     * Metodo para mostrar una Palabra en forma de cadena
     * @return String  -- datos de la palabra
     */
	public String toString() {
		return palabra + ": " + frecuencia;
	}
	
    /**
     * Metodo para determinar si dos Palabras son iguales
	 * @param o -- Palabra contra la cual se va a comparar
     * @return boolean  -- true si las Palabras son iguales, false en otro caso
     */
    public boolean equals(Object o) {
		if(o == this) return true;
		if(o == null) return false;
		if(o instanceof Palabra) {
			Palabra p = (Palabra)o;
			return (obtenerPalabra().toLowerCase().trim()).equals(p.obtenerPalabra().toLowerCase().trim());
		}
		return false;
    }
}