/**
 * Clase de nodos para arboles balanceados
 * @author Amparo López Gaona
 * @version 1a. ed.
 */
public class NodoAvl {
	
	public Object valor;           //Valor que almacenado en el nodo
	public NodoAvl izquierda;      //Liga a la izquierda
	public NodoAvl derecha;        //Liga a la derecha
	public int altura;
	
	/*
     * Constructor a partir de un valor
     * @param valor -- valor que se almacena en el nodo
     */
	public NodoAvl(Object valor) {
		this(valor, null, null );
	}

    /*
     * Constructor a partir de un valor y ligas al hijo izquierdo y al derecho
     * @param valor -- valor que se almacena en el nodo
     * @param izquierdo -- referencia al hijo izquiero
     * @param derecho -- referencia al hijo derecho
     */
	public NodoAvl( Object valor, NodoAvl izquierdo, NodoAvl derecho) {
		this.valor = valor;
	    this.izquierda = izquierdo;
	    this.derecha = derecho;
		altura = 0;
	}
}