import java.util.Comparator;
/**
 * Clase para probar la clase ArbolAvl.
 * @author Yazmin Gonzalez Bayardo
 * @version Septiembre 2015
 */
public class PruebaAvl {
	
	public static void main(String[] args){
		
		PruebaAvl pruebaAvl = new PruebaAvl();
		PruebaAvl.ComparaEnteros comparador = pruebaAvl.new ComparaEnteros();
		
		System.out.println("-- Creando arbol vacio");
		ArbolAvl arbolVacio = new ArbolAvl(comparador);
		System.out.println("Imprimiendo arbol... "); 
		arbolVacio.imprimirArbol();
		System.out.println("Eliminando elemento inexistente...");
		arbolVacio.eliminar(10);
		System.out.println("Tamanio del arbol: " + arbolVacio.tamanio());
		
		System.out.println("\n-- Creando arbol con un solo elemento: { 13 }");
		ArbolAvl arbolUnNodo = new ArbolAvl(comparador);
		arbolUnNodo.agregar(13);
		
		System.out.println("Imprimiendo arbol... "); 
		arbolUnNodo.imprimirArbol();
		System.out.println("Tamanio del arbol: " + arbolUnNodo.tamanio());
		
		System.out.println("\nEliminando elemento inexistente...");
		arbolUnNodo.eliminar(7);
		System.out.println("Imprimiendo arbol... "); 
		arbolUnNodo.imprimirArbol();
		System.out.println("Tamanio del arbol: " + arbolUnNodo.tamanio());
		
		System.out.println("\nEliminando elemento existente 13...");
		arbolUnNodo.eliminar(13);
		System.out.println("Imprimiendo arbol... "); 
		arbolUnNodo.imprimirArbol();
		System.out.println("Tamanio del arbol: " + arbolUnNodo.tamanio());
		
		
		System.out.println("\n-- Creando arbol con los siguientes elementos: { 10 15 7 13 14 8 4 20 19 12 11 28 1 }");
		ArbolAvl arbolAvl = new ArbolAvl(comparador);
		arbolAvl.agregar(10);
		arbolAvl.agregar(15);
		arbolAvl.agregar(7);
		arbolAvl.agregar(13);
		arbolAvl.agregar(14);
		arbolAvl.agregar(8);
		arbolAvl.agregar(4);
		arbolAvl.agregar(20);
		arbolAvl.agregar(19);
		arbolAvl.agregar(12);
		arbolAvl.agregar(11);
		arbolAvl.agregar(28);
		arbolAvl.agregar(1);
		
		System.out.println("Imprimiendo arbol... "); 
		arbolAvl.imprimirArbol();
		System.out.println("Tamanio del arbol: " + arbolAvl.tamanio());
		
		System.out.println("\nEliminando elemento 15 (prueba caso: nodo a eliminar sin hijos)...");
		arbolAvl.eliminar(15);
		System.out.println("Imprimiendo arbol... "); 
		arbolAvl.imprimirArbol();
		System.out.println("Tamanio del arbol: " + arbolAvl.tamanio());
		
		System.out.println("\nEliminando elemento 4 (prueba caso: nodo a eliminar con un solo hijo)...");
		arbolAvl.eliminar(4);
		System.out.println("Imprimiendo arbol... "); 
		arbolAvl.imprimirArbol();
		System.out.println("Tamanio del arbol: " + arbolAvl.tamanio());
		
		System.out.println("\nEliminando elemento 7 (prueba caso: nodo a eliminar con dos hijos)...");
		arbolAvl.eliminar(7);
		System.out.println("Imprimiendo arbol... "); 
		arbolAvl.imprimirArbol();
		System.out.println("Tamanio del arbol: " + arbolAvl.tamanio());
		
	}
	
	private class ComparaEnteros implements Comparator<Object> {
		public int compare(Object i1, Object i2){
			return (Integer)i1 - (Integer)i2;
		}
	}
}