/**
 * Interfaz para trabajar con colas de prioridad.
 * @author  Amparo Lopez Gaona.
 * @version 1a. ed.
 */
public interface InterfazColaConPrioridad {
    /**
     * Metodo para determinar si una cola de prioridad esta o no vacia.
     * @return boolean - true si la cola de prioridad esta vacia y false en otro caso.
     */
	public boolean estaVacia();
    /**
     * Metodo para eliminar todos los elementos de una cola de prioridad.
     */
	public void vaciar();
    /**
     * Metodo para conocer el tamano de una cola de prioridad.
     * @return int - cantidad de elementos en la cola de prioridad.
     */
	public int tamanio();
    /**
     * Metodo para obtener el primer elemento de la cola de prioridad sin alterar esta.
     * @return Object - elemento con menor prioridad en la cola.
     */
	public Object obtenerPrimero();
    /**
     * Metodo para agregar un elemento en la cola de prioridad.
     * @param elemento - elemento a almacenar en la cola de prioridad.
     */
	public void agregar(Object elemento);
    /**
     * Metodo para eliminar el menor elemento de la cola de prioridad.
     */
	public void eliminar();
	/**
	 * Metodo para obtener un iterador sobre la cola de prioridad.
	 * @return Iterator -- iterador sobre la cola de prioridad.
	 */
	public java.util.Iterator iterador();
}