import java.util.Comparator;
import java.util.Iterator;
/**
 * Clase para probar la clase Heap.
 * @author Yazmin Gonzalez Bayardo
 * @version Noviembre 2015
 */
public class PruebaHeap {
	
	private static class ComparaEnteros implements Comparator<Object> {
		public int compare(Object i1, Object i2){
			if( (i1 instanceof Integer) && (i2 instanceof Integer))
				return (Integer)i1 - (Integer)i2;
			else
				throw new IllegalArgumentException("Los objetos a comparar no son de la clase Integer");
		}
	}
	
	public static void main(String[] args) {
		
		Integer[] arr = new Integer[] {24,17,14,26,16,5,21,34,20,15,35};
		Heap heap = new Heap(new PruebaHeap.ComparaEnteros(), arr);
		
		System.out.println("\n-Imprimir contenido del heap:");
		heap.imprimirHeap();
		System.out.println("Tamanio: "+ heap.tamanio());
		
		
		System.out.println("\n-Cambiar elemento de la posicion 0 con el nuevo valor 18");
		heap.cambiar(0,18);
		System.out.println("Imprimir contenido del heap:");
		heap.imprimirHeap();
		
		System.out.println("\n-Cambiar elemento de la posicion 5 con el nuevo valor 7");
		heap.cambiar(4,7);
		System.out.println("Imprimir contenido del heap:");
		heap.imprimirHeap();
		
		System.out.println("\n-Cambiar ultimo elemento con el nuevo valor 12");
		heap.cambiar(10,12);
		System.out.println("Imprimir contenido del heap:");
		heap.imprimirHeap();
		
		System.out.println("\n-Tratar de cambiar con posicion inexistente 15");
		heap.cambiar(15,1);
		System.out.println("Imprimir contenido del heap:");
		heap.imprimirHeap();
		
		System.out.println("\n-Borrar elemento de la posicion 0");
		heap.borrar(0);
		System.out.println("Tamanio: "+ heap.tamanio());
		System.out.println("Imprimir contenido del heap:");
		heap.imprimirHeap();
		
		System.out.println("\n-Borrar elemento de la posicion 5");
		heap.borrar(5);
		System.out.println("Tamanio: "+ heap.tamanio());
		System.out.println("Imprimir contenido del heap:");
		heap.imprimirHeap();
		
		System.out.println("\n-Borrar elemento de la ultima posicion");
		heap.borrar(8);
		System.out.println("Tamanio: "+ heap.tamanio());
		System.out.println("Imprimir contenido del heap:");
		heap.imprimirHeap();
		
		System.out.println("\n-Tratar de borrar posicion inexistente 30");
		heap.borrar(30);
		System.out.println("Tamanio: "+ heap.tamanio());
		System.out.println("Imprimir contenido del heap:");
		heap.imprimirHeap();
		
		System.out.println("\n-Iterador en orden ascendente:");
		java.util.Iterator it = heap.iterador();
		while(it.hasNext()) {
			System.out.println(it.next());
		}
	}
}