import java.util.Comparator;
/**
 * Clase que implementa la interfaz Comparator para comparar Ordenes para la venta de acciones.
 * @author Yazmin Gonzalez Bayardo
 * @version Noviembre 2015
 */
public class ComparaOrdenesVenta implements Comparator<Object>{
	
	public int compare(Object o1, Object o2) {
		
		if( (o1 instanceof Orden) && (o2 instanceof Orden)){
			if(o1 == o2) return 0;
			
			Orden venta1 = (Orden)o1;
			Orden venta2 = (Orden)o2;
		
			return venta1.obtenerPrecio() - venta2.obtenerPrecio();
		}
		throw new IllegalArgumentException("Los objetos a comparar no son de la clase Orden.");
	}

}