/**
 * Interfaz para tablas de dispersion
 * @author Amparo Lopez Gaona
 * @version 1a. ed.
 */
public interface InterfazTablaDispersion{
    /**
     * Metodo para determinar si una tabla esta o no vacia.
     * @return boolean -- true si la tabla esta vacia y false en otro caso.
     */
    public boolean estaVacia ();

    /**
     * Metodo para eliminar todos los elementos de una tabla
     */
    public void vaciar();

    /**
     * Metodo para conocer la cantidad de elementos de una tabla
     * @return int -- cantidad de elementos en la tabla
     */
    public int tamanio ();

    /**
     * Metodo para introducir un elemento en la tabla
     * @param valor -- elemento a introducir en la tabla
     */
    public void agregar (Object valor);

    /**
     * Metodo para determinar si un valor se encuentra, o no, en la tabla 
	 * @param valor -- elemento a buscar en la tabla
	 * @return boolean -- true si el elemento buscado se encontro en la tabla, false en otro caso
     */
    public boolean contiene (Object valor);

    /**
     * Metodo para obtener el elemento correspondiente a la llave proporcionada.
     * La tabla no se modifica
	 * @param valor -- llave del elemento que se busca
	 * @return Object -- objeto asociado a la llave o null si no lo encuentra
     */
    public Object obtener (Object valor);

    /**
     * Metodo para obtener un iterador sobre la tabla
     * @return Iterator -- iterador sobre la tabla
     */    
    public java.util.Iterator iterador ();
}