/**
 * Interfaz que define las operaciones que se pueden realizar con polinomios de una variable con coeficientes enteros.  
 * @author Yazmin Gonzalez Bayardo
 * @version Febrero 2015
 */
public interface PolinomioTAD {
	
    /**
     * Metodo para determinar el grado del polinomio
     * @return int - Grado del polinomio
     */
	public int grado();
	
    /**
     * Metodo que devuelve la suma de dos polinomios
	 * @param poli - Polinomio que sera sumado al que llama este metodo
     * @return PolinomioTAD - Polinomio que resulta de la suma
     */
	public PolinomioTAD sumar(PolinomioTAD poli);
	
    /**
     * Metodo que devuelve la resta de dos polinomios
	 * @param poli - Polinomio que sera restado al que llama este metodo
     * @return PolinomioTAD - Polinomio que resulta de la resta
     */
	public PolinomioTAD restar(PolinomioTAD poli);
	
    /**
     * Metodo que devuelve la multiplicacion de dos polinomios
	 * @param poli - Polinomio que sera multiplicado al que llama este metodo
     * @return PolinomioTAD - Polinomio que resulta de la multiplicacion
     */
	public PolinomioTAD multiplicar(PolinomioTAD poli);
	
    /**
     * Metodo que imprime en pantalla los terminos que conforman al polinomio
     */
	public void imprimir();
	
    /**
     * Metodo que devuelve el polinomio evaluado
	 * @param d - valor que sera evaluado en el polinomio
     * @return double - resultado de la evaluacion
     */
	public double evaluar(double d);
}