/**
 * Clase que implementa la interfaz Comparator y permita comparar tareas de acuerdo a su prioridad.
 * @author Yazmin Gonzalez Bayardo
 * @version Marzo 2015
 */
import java.util.Comparator;

public class ComparaPrioridades implements Comparator<Object> {
	
	@Override
	public int compare(Object a, Object b) {
		
		if( (a instanceof Tarea) && (b instanceof Tarea)) {
			
			if(a == b) return 0;
			
			Tarea t1 = (Tarea)a;
			Tarea t2 = (Tarea)b;
		
			return t1.obtenerPrioridad() - t2.obtenerPrioridad();
		}
		throw new IllegalArgumentException("Los objetos a comparar no son de la clase Tarea");
	}
}