/**
 * Clase que implementa la interfaz Comparator y permita comparar peliculas de acuerdo a su calificacion.
 * @author Yazmin Gonzalez Bayardo
 * @version Marzo 2015
 */
import java.util.Comparator;

public class ComparaCalificacion implements Comparator<Object> {
	
	@Override
	public int compare(Object p1, Object p2) {
		
		if( (p1 instanceof Pelicula) && (p2 instanceof Pelicula)) {
			
			if(p1 == p2) return 0;
			
			Pelicula peli1 = (Pelicula)p1;
			Pelicula peli2 = (Pelicula)p2;
		
			return -1*(peli1.obtenerCalificacion() - peli2.obtenerCalificacion());
		}
		throw new IllegalArgumentException("Los objetos a comparar no son de la clase Pelicula");
	}
}