/**
 * Interfaz que describe las operaciones sobre listas
 * @author Amparo Lopez Gaona
 * @version 1a. ed.
 */
public interface InterfazLista {
    /**
     * Metodo para determinar si una lista esta o no vacia.
     * @return boolean -- true si la lista esta vacia y false en otro caso.
     */
    public boolean estaVacia();
    /**
     * Metodo para eliminar todos los elementos de una lista
     */
    public void vaciar();
    /**
     * Metodo para agregar un elemento a la lista
     * @param elemento -- Objeto que se incorporara a la lista
     */
    public void agregar(Object elemento); 
    /**
     * Metodo para determinar si un elemento pertenece a la lista
     * @param elemento -- Objeto que se va a buscar en la lista
     * @return true -- si el elemento esta en el lista y false en otro caso.
     */
    public boolean contiene(Object elemento);
    /** 
     * Metodo que devuelve el primer elemento de la lista 
     * @return Object -- elemento inicial de la lista
     **/
    public Object primerElemento();
    /**
     * Metodo para eliminar un elemento de la lista
     * @param elemento -- Objeto que se eliminara de la lista
     */
    public void eliminar(Object elemento);  
    /**
     * Metodo para sustituir el valor actual de un nodo por otro nuevo.
     * @param actual -- valor actual
     * @param nuevo -- nuevo valor
     */
    public void sustituir(Object actual, Object nuevo);
    /**
     * Metodo que devuelve un iterador sobre la lista
     * @return java.util.Iterador -- iterador sobre la lista
     */
    public java.util.Iterator iterador();
}