/**
 * Interfaz que describe las operaciones sobre pilas
 * @author Yazmin Gonzalez Bayardo
 * @version Abril 2015
 */
public interface PilaDoble {
    /**
     * Metodo para determinar si la pila esta vacia.
	 * @param pilaId -- identificador de la pila por validar si esta vacia
     * @return boolean -- true si la pila esta vacia y false en otro caso.
     */
    public boolean estaVacia (int pilaId);
	
    /**
     * Metodo para eliminar todos los elementos de la pila
	 * @param pilaId -- identificador de la pila por vaciar
     */
    public void vaciar(int pilaId);
	
    /** 
     * Metodo para obtener el elemento del tope de la pila sin modificarla
	 * @param pilaId -- identificador de la pila
     * @return Object -- ultimo elemento en entrar a la pila o null en caso de que la pila este vacia
     */
    public Object top(int pilaId);
	
    /** 
     * Metodo para sacar el elemento del tope de la pila
	 * @param pilaId -- identificador de la pila
     * @return Object -- ultimo elemento en entrar a la pila o null en caso de que la pila este vacia
     */	
    public Object pop(int pilaId);
	
    /**
     * Metodo para introducir un elemento en la pila
	 * @param pilaId -- identificador de la pila
     * @param elem -- elemento a introducir en la pila
     */
    public void push(int pilaId, Object elem);
	
    /**
     * Metodo para obtener un iterador sobre la pila
	 * @param pilaId -- identificador de la pila
     * @return Iterator -- iterador sobre la pila
     */
    public java.util.Iterator iterador(int pilaId);
}