/**
 * Clase que implementa la interfaz Comparator y permita comparar dos contenedores de acuerdo a su peso.
 * @author Yazmin Gonzalez Bayardo
 * @version Mayo 2015
 */
import java.util.Comparator;

public class ComparaContenedores implements Comparator<Object> {
	
	@Override
	public int compare(Object a, Object b) {
		
		if( (a instanceof Contenedor) && (b instanceof Contenedor)) {
			
			if(a == b) return 0;
			
			Contenedor c1 = (Contenedor)a;
			Contenedor c2 = (Contenedor)b;
		
			if(c1.obtenerPeso() < c2.obtenerPeso()) return -1;
			if(c1.obtenerPeso() > c2.obtenerPeso()) return 1;
			return 0;
		}
		throw new IllegalArgumentException("Los objetos a comparar no son de la clase Contenedor");
	}
}